<?php
/**
 * @fileID: $Id: addtocart.php 7838 2012-02-22 03:53:51Z alfiya $
 * @changedDate: $LastChangedDate: 2012-02-22 10:53:51 +0700 (Wed, 22 Feb 2012) $
 * @changedBy: $LastChangedBy: alfiya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgJoomsuite_content_fieldsAddtocart extends JPlugin
{

	function plgJoomsuite_content_fieldsAddtocart(&$subject, $params)
	{
		parent::__construct($subject, $params);
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if ($type != 'addtocart')
			return;
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if (key_exists($obj->id, $def))
			$obj->field_value = $def[$obj->id];
		
		$value = explode("::", $obj->field_value);
		
		$default = (isset($value[1])) ? $value[1] : '';
		if ($params->get('use_terms') && isset($obj->record_id))
		{
			require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'helper.php');
			$section_id = ResHelper::getArticleSection($obj->record_id);
			
			$db = JFactory::getDBO();
			$sql = "SELECT ju.params FROM #__jc_users ju
			JOIN #__js_res_record rr ON rr.user_id = ju.user_id
			WHERE rr.id = '{$obj->record_id}' AND ju.section_id = '$section_id'";
			$db->setQuery($sql);
			$SP = $db->loadResult();
			$SP = new JParameter($SP);
			$default = (isset($value[1]) && $value[1] != '') ? $value[1] : $SP->get('usr_terms', '');
		}
		
		?>
<span class="hasTip"
	title="<?php
		echo JText::_('Add To Cart field') . '::' . JText::_('Select default items number that will be added to cart');
		?>"> <input type="text" style="width: 100px;"
	name="fields[<?php
		echo $obj->id?>][]"
	value="<?php
		echo ($value[0] ? $value[0] : '1');
		?>" /> </span>
<?php
		if ($params->get('use_terms'))
		{
			echo '<br><br>' . JText::_('Terms and conditions');
			?>
:
<br>
<textarea name="fields[<?php
			echo $obj->id?>][]" cols="50" rows=""><?php
			echo $default;
			?></textarea>
<?php
		}
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if ($type != 'addtocart')
			return;
		if (!$value)
			return;
		
		$value = implode("::", $value);
		
		$db = &JFactory::getDBO();
		$value = $db->getEscaped(trim($value));
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if ($field->type != 'addtocart')
			return;
		if (JRequest::getVar('format') == 'feed')
			return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		//hack for Touch profile
		if (JRequest::getVar('option') == "com_community")
		{
			$sell_in_profile = 'Community';
		}
		
		if (!$field->field_value)
			$field->field_value = '1';
		$uri = JFactory::getURI();
		$value = explode('::', $field->field_value);
		$db = &JFactory::getDBO();
		$c_user = JFactory::getUser();
		
		require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'helper.php');
		$section_id = ResHelper::getCategorySection(JRequest::getInt('category_id'));
		if (!$section_id)
			$section_id = ResHelper::getArticleSection($field->record_id);
		
		if (!$section_id)
			return;
		$comm_params = ResHelper::getSectionParams($section_id);
		$commerce = JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_commerce' . DS . 'commerce.php';
		if (!file_exists($commerce))
			return;
		
		require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_commerce' . DS . 'controllers' . DS . 'config.php');
		CommerceControllerConfig::initialyze($comm_params, $section_id);
		
		include_once (JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'resource.xajax.php');
		
		$out = '';
		$pre = '';
		if ($comm_params->get('comm_enabled'))
		{
			if (COMM_CART == 'balance')
			{
				if (!$c_user->id)
				{
					$out = JText::_('You have to be registered and logged in to buy the product');
					return;
				}
				else
				{
					$customer_bal = $this->getCustomerBalance($c_user->id, $section_id);
					
					if ((!COMM_ALLOW_NEGATIVE_CUSTOMER && (!$customer_bal || $customer_bal->balance <= 0)) || (COMM_ALLOW_NEGATIVE_CUSTOMER && $customer_bal <= COMM_NEGATIVE_LIMIT_CUSTOMER))
					{
						$out = JText::_('Your balance does not let you to purchase the product.');
						if (!COMM_CUSTOMER_PILEUP)
						{
							$out .= '
							<dl id="system-message">
								<dt class="error">Message</dt>
								<dd class="error">
								<ul>
									<li>' . JText::_("Error") . ': ' . JText::_('Bill to pile up the balance is not selected') . '. ' . JText::_('Please let Administrator know about this issue.') . '
									</li>
								</ul>
								</dd>
							</dl>';
						}
						else
						{
							$return = JRoute::_("index.php?option=com_commerce&view=balance&layout=customer&section_id=" . $section_id . "&Itemid=" . ((COMM_BALANCE_ITEMID != '') ? COMM_BALANCE_ITEMID : JRequest::getInt('Itemid')), false);
							$return .= '&return=' . base64_encode($uri->toString());
							$link = 'index.php?option=com_jsbill&view=bill&bill=' . COMM_CUSTOMER_PILEUP . '&Itemid=' . ((COMM_BILL_ITEMID != '') ? COMM_BILL_ITEMID : JRequest::getInt('Itemid')) . '&return_success=' . base64_encode($return) . '&return_fail=' . base64_encode($return);
							$link = $return;
							
							$out .= '<p>' . JText::_('Please pile up a balance to make purchases') . ' ' . JHTML::link($link, '<b>' . JText::_('here') . '</b>', 'target="_blank"') . '</p>';
						}
						return;
					}
				}
			}
			require_once (JPATH_ROOT . DS . 'components' . DS . 'com_commerce' . DS . 'helpers' . DS . 'extensions.php');
			$author = jcUser::getSeller($user);
			
			if (!$author->is_seller && !$author->is_silver && !$author->is_gold)
				return;
			
			$sql = "SELECT catid FROM #__js_res_record_category WHERE record_id = '{$field->record_id}'";
			$db->setQuery($sql);
			$catid = $db->loadResult();
			if (JRequest::getString('option') == 'com_resource' && JRequest::getString('view') != 'list')
				$url = $uri->toString();
			else
				$url = 'index.php?option=com_resource&controller=article&article=' . $field->record_id . '&category_id=' . $catid . '&Itemid=' . JRequest::getInt('Itemid');
				
			/*  // add to cart template button
			 if($c_user->id == $user)
			 {
				if(JRequest::getString('option') == 'com_resource' && JRequest::getString('controller') == 'article')
				$pre .= '<form>';
				$pre .= '
				<table width="100%">
				<tr>
				<td width="1%">
				<input type="text" class="inputbox" size="5" maxlength="10" id="precart_item_number-'.$field->record_id.'"
				name="precart_item_number" value="'.$value[0].'"
				onKeyUp="formatInt(\'precart_item_number-'.$field->record_id.'\');">
				</td>
				<td nowrap>
				<input type="button" class="button"
				value="'.JText::_("Add to cart template").'"
				name="preadd" id="preaddtocart-'.$field->record_id.'"
				onclick="var amount = document.getElementById(\'precart_item_number-'.$field->record_id.'\').value;
				if(amount <= 0) alert(\''.JText::_('Quantity could not be zero ').'\');
				else {
				showLoadingImg(\'preaddToCartLoading-'.$field->record_id.'\');
				xajax_jsCallPlugin(\'joomsuite_content_fields\', \'addtocart\', \'xajax_jcAddToPreCart\', ['.$field->record_id.', amount, '.$field->fid.', \''.$url.'\']); }">
					
				<span id="preaddToCartLoading-'.$field->record_id.'"></span>
				</td>
				</tr>
				</table>
				<div id="preaddtocartDiv-'.$field->record_id.'"></div>';

				if(JRequest::getString('option') == 'com_resource' && JRequest::getString('controller') == 'article')
				$pre .= '</form>';
				}*/
			
			$negative = COMM_ALLOW_NEGATIVE;
			$negative_limit = COMM_NEGATIVE_LIMIT;
			if ($author->is_silver)
			{
				$negative = COMM_ALLOW_NEGATIVE_SILVER;
				$negative_limit = COMM_NEGATIVE_LIMIT_SILVER;
			}
			if ($author->is_gold)
			{
				$negative = COMM_ALLOW_NEGATIVE_GOLD;
				$negative_limit = COMM_NEGATIVE_LIMIT_GOLD;
			}
			
			$balance = $this->getAuthorBalance($user, $section_id);
			
			if ($c_user->id == $user && $params->get('show_balance_alert', 1))
			{
				if ($balance && (($negative && $negative_limit > $balance->balance) || (!$negative && $balance->balance <= 0))) //$balance->balance == 0 ||
				{
					$balance_link = 'index.php?option=com_commerce&view=balance&task=pileup&section_id=' . $section_id . '&Itemid=' . JRequest::getInt('Itemid');
					$out .= '<span class="small" style="color: red">' . JText::_('You have negative balance. To continue sell the products you need to pile it up clicking on the following link') . ' ' . JHTML::link(JRoute::_($balance_link, false), '<b>' . JText::_('here') . '</b>', 'target="_blank"') . '</span><br>';
				}
			}
			
			if (!$balance || ($balance && (($negative && $negative_limit < $balance->balance) || (!$negative && $balance->balance > 0)))) // $balance->balance == 0 ||
			{
				$disable = '';
				
				if ($params->get('use_terms') && isset($value[1]) && $value[1] != '')
				{
					$out .= '<div style="overflow: auto; width: 80%; height: 100px; border: 1px solid #333; padding: 3px;">';
					$out .= '<b>' . JText::_('Terms and Conditions of Trade') . '</b>:';
					$out .= '<p>' . $value[1] . '</p> ';
					$out .= '</div>';
					$out .= '<p><input type="checkbox" name="agree[' . $field->record_id . ']" value="1" onclick="checkAddButton(this.checked, ' . $field->record_id . ')"> ' . JText::_('I have read and agree with these terms') . '</p>';
					
					$disable = 'disabled';
				}
				
				if (JRequest::getString('option') == 'com_resource' && JRequest::getString('controller') == 'article')
					$out .= '<form>';
				$out .= '
				<table width="100%">
					<tr>
						<td width="1%">
							<input type="text" class="inputbox" size="5" maxlength="10" id="cart_item_number-' . $field->record_id . '" 
								name="cart_item_number" value="' . $value[0] . '" ' . $disable . '
								onKeyUp="formatInt(\'cart_item_number-' . $field->record_id . '\');">
						</td>
						<td nowrap>
							<input type="button" class="button" ' . $disable . '
							value="' . ((COMM_CART_MODE == 'multi') ? JText::_("Put to cart") : ((COMM_CART == 'cart' || COMM_CART == 'balance') ? JText::_("Buy now") : JText::_("Inquire now"))) . '" 
							name="add" id="addtocart-' . $field->record_id . '"
							onclick="AddToCart' . $field->record_id . '()">';
				$product_suite = $this->checkFieldExists($field->record_id, 'product_suite');
				
				if ($product_suite)
				{
					$suite = $product_suite->field_value;
					if ($suite != '')
					{
						$suite = unserialize($suite);
						if (isset($suite['items']))
						{
							foreach($suite['items'] as $item)
							{
								$ids[] = $item['id'];
								$amounts[] = $item['amount'];
							}
							$js = '
							xajax_js' . $sell_in_profile . 'CallPlugin(\'joomsuite_content_fields\', \'addtocart\', \'xajax_jcAddSuiteToCart\', [amount, \'' . implode(';', $ids) . '\', \'' . implode(';', $amounts) . '\', ' . $field->fid . ', ' . $user . ', totals, \'' . $field->record_id . '\', \'' . $suite['discount'] . '\', \'' . $params->get('open_cart') . '\']);
							';
						}
						else
						{
							$js = 'xajax_js' . $sell_in_profile . 'CallPlugin(\'joomsuite_content_fields\', \'addtocart\', \'xajax_jcAddToCart\', [' . $field->record_id . ', amount, ' . $field->fid . ', ' . $user . ', totals, \'' . $url . '\', \'' . $params->get('open_cart') . '\']);';
						}
					}
				}
				else
					$js = 'xajax_js' . $sell_in_profile . 'CallPlugin(\'joomsuite_content_fields\', \'addtocart\', \'xajax_jcAddToCart\', [' . $field->record_id . ', amount, ' . $field->fid . ', ' . $user . ', totals, \'' . $url . '\', \'' . $params->get('open_cart') . '\']);';
				
				$out .= '
							<span id="addToCartLoading-' . $field->record_id . '"></span>
						</td>
					</tr>
				</table>';
				$out .= '<script type="text/javascript">
				function AddToCart' . $field->record_id . '()
				{
					var amount = document.getElementById("cart_item_number-' . $field->record_id . '").value;
					if(amount <= 0) 
						alert("' . JText::_('Quantity could not be zero ') . '");
					else 
					{
						showLoadingImg("addToCartLoading-' . $field->record_id . '");
						var totals = Array();
						try {
						Array.each($$("[id^=\'modCartContentTotal\']"), function (item) {						
							var name = item.id.split("-");						
							totals[name[1]] = item.textContent;				
						});
						} catch(e) { }
						' . $js . '
					}
				}
				</script>';
				
				$out .= '<div id="addtocartDiv-' . $field->record_id . '"></div>';
				
				if (JRequest::getString('option') == 'com_resource' && JRequest::getString('controller') == 'article')
					$out .= '</form>';
				$out .= $pre;
				
				$out .= '
			<script language="JavaScript">
				function showLoadingImg(id)
				{
					document.getElementById(id).innerHTML = "<img src=\'' . JURI::root() . 'administrator/components/com_resource/images/load.gif\' align=\'absmiddle\'>";
				}
				function setContent(id, val)
				{
					var d = document;
					if(d.getElementById(id))
					d.getElementById(id).innerHTML = val;
				}
				function formatInt(id)
				{
					var cur = document.getElementById(id).value;
					reg = /[^\d]+/;
					cur = cur.replace(reg, "");
					document.getElementById(id).value = cur;
				}
				function checkAddButton(val, id)
				{
					if(val)
					{
						document.getElementById("cart_item_number-" + id).disabled = false;
						document.getElementById("addtocart-" + id).disabled = false;
					}
					else
					{
						document.getElementById("cart_item_number-" + id).disabled = true;
						document.getElementById("addtocart-" + id).disabled = true;
					}
				}
			</script>';
			}
			else
			{
				$out .= '<input type="text" class="inputbox" size="5" id="cart_item_number-' . $field->record_id . '"
								name="cart_item_number" value="' . $value[0] . '" disabled
								onKeyUp="formatInt(\'cart_item_number-' . $field->record_id . '\');">
						<input type="button" class="button" disabled
							value="' . ((COMM_CART_MODE == 'multi') ? JText::_("Put to cart") : ((COMM_CART == 'cart' || COMM_CART == 'balance') ? JText::_("Buy now") : JText::_("Inquire now"))) . '" 
							name="add" id="addtocart-' . $field->record_id . '">';
				$out .= '<p><b>' . JText::_('You can not purchase this product temporarily. Seller is unavailable.') . '</b></p>';
				/*$out .= '<dl id="system-message">
				 <dt class="message">Message</dt>
				 <dd class="message">
				 <ul>
				 <li id="cartError">'.JText::_('You can not purchase this product temporarily. Seller is not available for the moment.').'</li>
				 </ul>
				 </dd>
				 </dl>';*/
			}
		}
	}

	function getAuthorBalance($uid, $section_id)
	{
		$db = JFactory::getDBO();
		$sql = "SELECT balance_id FROM #__jc_users u WHERE u.user_id = '$uid' AND u.section_id = '$section_id'";
		$db->setQuery($sql);
		if ($res = $db->loadObject())
		{
			if (!$res->balance_id)
			{
				return false;
			}
			$sql = "SELECT balance FROM #__jc_users_balance
			WHERE id = '{$res->balance_id}' AND section_id = '$section_id'";
			$db->setQuery($sql);
			return $db->loadObject();
		}
		else
			return false;
	}

	function getCustomerBalance($uid, $section_id)
	{
		$db = JFactory::getDBO();
		$sql = "SELECT * FROM #__jc_customers_balance
		WHERE user_id = '$uid' AND section_id = '$section_id'
		ORDER BY id DESC
		LIMIT 0, 1";
		$db->setQuery($sql);
		return $res = $db->loadObject();
	}

	function getSellerId($id)
	{
		$db = JFactory::getDBO();
		$query = "SELECT user_id FROM #__js_res_record WHERE id = '$id'";
		$db->setQuery($query);
		return $db->loadResult();
	}

	function getCore($id)
	{
		$db = & JFactory::getDBO();
		$query = "
           SELECT c.name, c.code, IF(c.mark != '', c.mark, c.code) as mark
             FROM #__jc_currency AS c
            WHERE c.id = " . $id;
		$db->setQuery($query);
		return $db->loadObject();
	}

	function checkFieldExists($id, $field)
	{
		$db = & JFactory::getDBO();
		
		$sql = "SELECT v.field_value, v.field_id, f.params
		FROM #__js_res_record_values v
		JOIN #__js_res_record r ON v.record_id = r.id
		JOIN #__js_res_fields f ON v.field_id = f.id
		WHERE r.id = '$id' AND f.type='$field' AND f.published = '1'";
		$db->setQuery($sql);
		return $db->loadObject();
	}

	function isTangible($rid)
	{
		$db = & JFactory::getDBO();
		if (is_array($rid))
		{
			$query = "SELECT ex.value, f.params FROM #__js_res_field_extra ex
		JOIN #__js_res_fields f ON ex.field_id = f.id
		WHERE ex.record_id IN (" . implode(",", $rid) . ") AND ex.ref_id = 'tangible' AND f.published = '1'";
		}
		else
		{
			$query = "SELECT ex.value, f.params FROM #__js_res_field_extra ex
			JOIN #__js_res_fields f ON ex.field_id = f.id
			WHERE ex.record_id = '$rid' AND ex.ref_id = 'tangible' AND f.published = '1'";
		
		}
		$db->setQuery($query);
		$res = $db->loadObjectList();
		$return = false;
		foreach($res as $row)
		{
			$val = new JParameter($row->value);
			if ($val->get('weight') > 0)
			{
				$return = $res;
				break;
			}
		}
		return $return;
	}

	function xajax_jcAddToCart(&$objResponse, $rid, $items_num, $fid, $author_id, $total, $url, $opencart)
	{
		$objResponse = new JS_SAFE_xajaxResponse();
		$user = JFactory::getUser()->get('id');
		//	$user = @$user->get('id');
		$session = & JFactory::getSession();
		$uri = JFactory::getURI();
		$db = JFactory::getDBO();
		
		$section_id = 0;
		require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'helper.php');
		if ($catid = JRequest::getInt('category_id'))
		{
			$section_id = ResHelper::getCategorySection($catid);
		}
		if (JRequest::getVar('controller') == 'article' && $aid = JRequest::getInt('article_id'))
		{
			$section_id = ResHelper::getArticleSection($aid);
		}
		if (!$section_id)
			$section_id = ResHelper::getArticleSection($rid);
		
		if (!$section_id)
			return $objResponse;
		
		$comm_params = ResHelper::getSectionParams($section_id);
		
		require_once (JPATH_ROOT . DS . 'administrator/components/com_commerce/controllers' . DS . 'config.php');
		CommerceControllerConfig::initialyze($comm_params, $section_id);
		
		$module = array();
		$modules_loaded = JModuleHelper::_load();
		foreach($modules_loaded as $item)
		{
			if ($item->module == 'mod_commerce_cart')
			{
				$item->params = new JParameter($item->params);
				$module[] = $item;
			}
		}
		
		$price = 0;
		$tax = 0;
		$err_txt = '';
		$err = '<dl id="system-message">
				<dt class="notice">Message</dt>
				<dd class="notice">
					<ul>
						<li id="cartError">[NOTICE]</li>
					</ul>
				</dd>
	 		</dl>';
		$ok = '<dl id="system-message">
						<dt class="message">Message</dt>
						<dd class="message">
							<ul>
								<li id="cartError">[NOTICE]</li>
							</ul>
						</dd>
			  		</dl>';
		$sql = "SELECT * FROM #__js_res_field_extra fex
		JOIN #__js_res_fields f ON f.id = fex.field_id WHERE fex.record_id = '$rid' AND fex.ref_id = 'download' AND f.published = '1'";
		$db->setQuery($sql);
		$allowed = 1;
		if ($ptypes = $db->loadObjectList())
		{
			$allowed = 0;
			foreach($ptypes as $ptype)
			{
				if ($ptype->field_value_id != 1)
					$allowed ++;
				else
				{
					if ($ptype->ip == '')
						$allowed ++;
				}
			}
		}
		if (!$allowed)
		{
			$err_txt = JText::_('You can not add this item to cart. Unique file has been already purchased.');
			$err = str_replace('[NOTICE]', $err_txt, $err);
			$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
			$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
			return $objResponse;
		}
		
		$multivendor = COMM_MULTI_VENDOR;
		if (COMM_PAYMENT_METHOD == 'personal' && COMM_CART == 'cart')
			$multivendor = false;
		
		$cart = ($session->get('my_cart' . '-' . $section_id) && COMM_CART_MODE != 'buy_now') ? $session->get('my_cart' . '-' . $section_id) : array();
		
		$cart_set = ($session->get('my_cart' . '-' . $section_id) && COMM_CART_MODE != 'buy_now') ? $session->get('my_cart' . '-' . $section_id) : array();
		
		if ($items_num > 0)
		{
			$sql = "SELECT title, published FROM #__js_res_record WHERE id = '$rid'";
			$db->setQuery($sql);
			$art_info = $db->loadObject();
			$title = $art_info->title;
			if (!$art_info->published)
			{
				$err_txt = JText::_('You can not add unpublished product to cart');
				$err = str_replace('[NOTICE]', $err_txt, $err);
				$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
				$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
				return $objResponse;
			}
			
			$sql = "SELECT rv.field_value as price
			FROM #__js_res_record r
			JOIN #__js_res_fields f ON r.type_id = f.type_id
			JOIN #__js_res_record_values rv ON rv.field_id = f.id
			WHERE rv.record_id = '{$rid}' AND f.type = 'price'
			AND f.published = '1'
			group by rv.id";
			$db->setQuery($sql);
			$price = $db->loadResult();
			if ($price == '')
				$price = 0;
			if ($price)
			{
				$sql = "SELECT value FROM #__js_res_field_extra WHERE ref_id = 'price_ext' AND record_id = '{$rid}'";
				$db->setQuery($sql);
				if ($extra = $db->loadResult())
				{
					$val = unserialize($extra);
					if ($val['tax_id'])
					{
						$sql = "SELECT rate, name FROM #__jc_taxes WHERE id = '{$val['tax_id']}'";
						$db->setQuery($sql);
						$tax = $db->loadObject();
						$price += $price * $tax->rate / 100;
					}
				}
			}
			$price = round($price, 2);
			
			if (!isset($cart[$author_id]))
				$cart[$author_id] = array();
			$new_key = ($cart[$author_id] && count($cart[$author_id])) ? count($cart[$author_id]) : 0;
			/*$keys = array_keys($cart);
			$new_key = (count($cart) > 0 && COMM_CART_MODE != 'buy_now') ? $keys[count($keys)-1] + 1 : 0;*/
			$amount = $items_num;
			$count = 0;
			foreach($cart as $items)
			{
				$count += count($items);
				foreach($items as $item)
					$amount += $item->items_num;
			}
			$amount = ($amount == 1) ? JText::_("There is 1 item in the cart") : str_replace("[AMOUNT]", $amount, JText::_("There are [AMOUNT] items in the cart"));
			
			//JPluginHelper::importPlugin('joomsuite_content_fields', 'addtocart');
			//$author_id = $this->getSellerId($rid);
			$core = $this->getCore(COMM_CORE_CURRENCY);
			
			foreach($module as $k => $mod)
			{
				$out[$mod->id] = '';
				
				if (!$mod->params->get('define_sec', 0) && $mod->params->get('default_section') != $section_id)
					continue;
				if ($count < $mod->params->get('max_items'))
				{
					if ($mod->params->get('show_items'))
					{
						$out[$mod->id] = '<tr><td>' . ($count + 1) . '. <a href="' . $url . '">' . $title . '</a></td>';
						if ($mod->params->get('show_amount'))
							$out[$mod->id] .= '<td width="1%" align="right" nowrap>' . $items_num . ' x </td>';
						if ($mod->params->get('show_price'))
							$out[$mod->id] .= '<td align="right" nowrap>' . str_replace(array('00', 'Sign'), array(round($price, 2), $core->mark), COMM_LAYOUT_PRICE) . ' = </td>';
						if ($mod->params->get('show_sum'))
							$out[$mod->id] .= '<td align="right" nowrap>' . str_replace(array('00', 'Sign'), array(round($price * $items_num, 2), $core->mark), COMM_LAYOUT_PRICE) . '</td>';
						if ($mod->params->get('show_delete'))
						{
							$return = base64_encode(JFactory::getURI()->toString());
							$remove = JRoute::_('index.php?option=com_commerce&view=cart&section_id=' . $section_id . '&return=' . $return . '&cart_item_remove=' . $author_id . '::' . $new_key, false);
							$out[$mod->id] .= '<td><a class="removeLink" href="javascript: void(0);"
					onClick=\'if(confirm("' . JText::_('Remove item?') . '")) { document.location = "' . $remove . '" } \'>
								<img src="' . JURI::root() . 'components/com_commerce/images/remove.png" alt="' . JText::_('Remove') . '" align="absmiddle">
							</a></td>';
						}
					}
				}
				$amounts[$mod->id] = $amount;
				
				$total[$mod->id] = str_replace($core->mark, '', $total[$mod->id]);
				$total[$mod->id] = str_replace(array('00', 'Sign'), array(round($total[$mod->id] + $price * $items_num, 2), $core->mark), COMM_LAYOUT_PRICE);
			
			}
			
			$cart[$author_id][$new_key]->items_num = $items_num;
			$cart[$author_id][$new_key]->article = $rid;
			$cart[$author_id][$new_key]->link = $url;
			
			// BUY NOW ********
			if (COMM_CART_MODE == 'buy_now')
			{
				$link = 'index.php?option=com_commerce&view=cart&section_id=' . COMM_SECTION_ID . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt("Itemid"));
				$link = JRoute::_($link, false);
				
				$session->clear('my_cart' . '-' . $section_id);
				$session->set('my_cart' . '-' . $section_id, $cart);
				
				$objResponse->script("parent.document.location = '" . $link . "';");
				return $objResponse;
			}
			// BUY NOW ******* END
			

			$tangible = $this->isTangible($rid);
			$tangible = $tangible[0];
			
			// Multivendor ********
			if ($multivendor)
			{
				if (COMM_CART == 'cart')
				{
					if (count($cart) > 0)
					{
						if ($tangible)
						{
							$tang_params = new JParameter($tangible->value);
							if ($tang_params->get('weight'))
							{
								if (!$tang_params->get('storage', 0))
								{
									$err_txt = JText::_('You can not add this product to cart.') . '<li>' . JText::_('There are no items on storage');
									$err = str_replace('[NOTICE]', $err_txt, $err);
									$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
									$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
									return $objResponse;
								}
								else
								{
									$in_cart = 0;
									foreach($cart_set as $items)
									{
										foreach($items as $items)
										{
											if ($rid == $item->article)
											{
												$in_cart += $item->items_num;
											}
										}
									}
									if (!$in_cart || ($tang_params->get('storage') >= ($tang_params->get('storage') - $in_cart) && ($tang_params->get('storage') - $in_cart) > 0))
									{
										if ($items_num > ($tang_params->get('storage') - $in_cart))
											$cart[$author_id][$new_key]->items_num = $tang_params->get('storage') - $in_cart;
									}
									else
									{
										$err_txt = JText::_('You can not add this product to cart.') . '<li>' . JText::_('There are no items on storage more than you have added to cart');
										$err = str_replace('[NOTICE]', $err_txt, $err);
										$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
										$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
										return $objResponse;
									}
								}
							}
							else
							{
								if (COMM_PAYMENT_METHOD == 'personal' && !in_array($author_id, array_keys($cart)))
								{
									$err_txt = JText::_('You can not add tangible product to cart because you already have products of other sellers in the cart.') . '<li>' . JText::_('First delete items form the cart or finish your payment.');
									$err = str_replace('[NOTICE]', $err_txt, $err);
									$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
									$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
									return $objResponse;
								}
							}
						
						}
						else
						{
							$ids = array();
							foreach($cart as $seller_id => $items)
							{
								foreach($items as $item)
								{
									$ids[] = $item->article;
								}
							}
							$tangibles = $this->isTangible($ids);
							if ($tangibles)
							{
								$tang = false;
								foreach($tangibles as $val)
								{
									$weights = new JParameter($val->value);
									if ($weights->get('weight'))
									{
										$tang = true;
									}
								}
								if ($tang)
								{
									if (!in_array($author_id, array_keys($cart)))
									{
										$err_txt = JText::_('You can not add this product to cart because you already have tangible product of other seller in the cart.') . '<li>' . JText::_('First delete items form the cart or finish your payment.');
										$err = str_replace('[NOTICE]', $err_txt, $err);
										$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
										$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
										return $objResponse;
									}
								}
							}
						}
					}
				}
				$session->set('my_cart' . '-' . $section_id, $cart);
				
				if (count($module))
				{
					foreach($module as $mod)
					{
						if ($out[$mod->id] != '')
						{
							if (!count($cart_set))
								$objResponse->assign('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
							else
								$objResponse->append('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
						}
						if (isset($amounts[$mod->id]))
							$objResponse->assign('modCartContentAmount' . $mod->id, "innerHTML", $amounts[$mod->id]);
						$objResponse->assign('modCartContentTotal-' . $mod->id, "innerHTML", '<b>' . $total[$mod->id] . '</b>');
					}
				}
				$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
				$err_txt = $cart[$author_id][$new_key]->items_num . ' ' . (($cart[$author_id][$new_key]->items_num == 1) ? JText::_('Item is added to cart') : JText::_('Items are added to cart'));
				$ok = str_replace('[NOTICE]', $err_txt, $ok);
				$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $ok);
			}
			// Multivendor ******** END
			

			// SINGLE vendor ********
			else
			{
				if ($tangible)
				{
					$tang_params = new JParameter($tangible->value);
					if ($tang_params->get('weight'))
					{
						if (!$tang_params->get('storage', 0))
						{
							$err_txt = JText::_('You can not add this product to cart.') . '<li>' . JText::_('There are no items on storage');
							$err = str_replace('[NOTICE]', $err_txt, $err);
							$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
							$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
							return $objResponse;
						}
						else
						{
							$in_cart = 0;
							foreach($cart_set as $items)
							{
								foreach($items as $items)
								{
									if ($rid == $item->article)
									{
										$in_cart += $item->items_num;
									}
								}
							}
							if (!$in_cart || ($tang_params->get('storage') >= ($tang_params->get('storage') - $in_cart) && ($tang_params->get('storage') - $in_cart) > 0))
							{
								if ($items_num > ($tang_params->get('storage') - $in_cart))
									$cart[$author_id][$new_key]->items_num = $tang_params->get('storage') - $in_cart;
							}
							else
							{
								$err_txt = JText::_('You can not add this product to cart.') . '<li>' . JText::_('There are no items on storage more than you have added to cart.');
								$err = str_replace('[NOTICE]', $err_txt, $err);
								$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
								$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
								return $objResponse;
							}
						}
					}
				}
				
				if (count($cart) > 0)
				{
					if (!in_array($author_id, array_keys($cart)))
					{
						$err_txt = JText::_('You can not add products of different sellers to cart.') . '<li>' . JText::_('First delete items form the cart or finish your payment.');
						$err = str_replace('[NOTICE]', $err_txt, $err);
						$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
						$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
						return $objResponse;
					}
					else
					{
						$session->set('my_cart' . '-' . $section_id, $cart);
						
						if (count($module))
						{
							foreach($module as $mod)
							{
								if (!$new_key)
									$objResponse->assign('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
								else
									$objResponse->append('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
								if (isset($amounts[$mod->id]))
									$objResponse->assign('modCartContentAmount' . $mod->id, "innerHTML", $amounts[$mod->id]);
								$objResponse->assign('modCartContentTotal-' . $mod->id, "innerHTML", '<b>' . $total[$mod->id] . '</b>');
							}
						}
						$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
						$err_txt = $cart[$author_id][$new_key]->items_num . ' ' . (($cart[$author_id][$new_key]->items_num == 1) ? JText::_('Item is added to cart') : JText::_('Items are added to cart'));
						$ok = str_replace('[NOTICE]', $err_txt, $ok);
						$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $ok);
					}
				}
				else
				{
					$session->set('my_cart' . '-' . $section_id, $cart);
					
					if (count($module))
					{
						foreach($module as $mod)
						{
							if (!$new_key)
								$objResponse->assign('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
							else
								$objResponse->append('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
							if (isset($amounts[$mod->id]))
								$objResponse->assign('modCartContentAmount' . $mod->id, "innerHTML", $amounts[$mod->id]);
							$objResponse->assign('modCartContentTotal-' . $mod->id, "innerHTML", '<b>' . $total[$mod->id] . '</b>');
						}
					}
					$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
					$err_txt = $cart[$author_id][$new_key]->items_num . ' ' . (($cart[$author_id][$new_key]->items_num == 1) ? JText::_('Item is added to cart') : JText::_('Items are added to cart'));
					$ok = str_replace('[NOTICE]', $err_txt, $ok);
					$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $ok);
				}
			
			}
		
		// SINGLE vendor ********
		

		}
		if ($opencart)
		{
			global $mainframe;
			$link = 'index.php?option=com_commerce&view=cart&section_id=' . $section_id . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
			$link = JRoute::_($link, false);
			$objResponse->redirect($link);
		}
		return $objResponse;
	}

	function xajax_jcAddSuiteToCart(&$objResponse, $suite_amount, $rids, $amounts, $fid, $author_id, $total, $parent, $discount = '', $opencart)
	{
		//$objResponse = new JS_SAFE_xajaxResponse();
		$user = JFactory::getUser();
		$user = @$user->get('id');
		$session = & JFactory::getSession();
		$uri = JFactory::getURI();
		$db = JFactory::getDBO();
		
		$rids = explode(';', $rids);
		$amounts = explode(';', $amounts);
		
		$section_id = 0;
		require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'helper.php');
		
		$section_parent = ResHelper::getArticleSection($parent);
		$comm_params = ResHelper::getSectionParams($section_parent);
		
		require_once (JPATH_ROOT . DS . 'administrator/components/com_commerce/controllers' . DS . 'config.php');
		CommerceControllerConfig::initialyze($comm_params, $section_parent);
		
		$module = array();
		$modules_loaded = JModuleHelper::_load();
		foreach($modules_loaded as $item)
		{
			if ($item->module == 'mod_commerce_cart')
			{
				$item->params = new JParameter($item->params);
				$module[] = $item;
			}
		}
		
		$step = 0;
		$errs = array();
		$err = '<dl id="system-message">
				<dt class="notice">Message</dt>
				<dd class="notice">
					<ul>
						<li id="cartError">[NOTICE]</li>
					</ul>
				</dd>
	 		</dl>';
		$ok = '<dl id="system-message">
						<dt class="message">Message</dt>
						<dd class="message">
							<ul>
								<li id="cartError">[NOTICE]</li>
							</ul>
						</dd>
			  		</dl>';
		
		$sql = "SELECT title, published FROM #__js_res_record WHERE id = '$parent'";
		$db->setQuery($sql);
		$art_info = $db->loadObject();
		if (!$art_info->published)
		{
			$err_txt = JText::_('You can not add unpublished product to cart');
			$err = str_replace('[NOTICE]', $err_txt, $err);
			$objResponse->assign('addToCartLoading-' . $parent, 'innerHTML', '');
			$objResponse->assign('addtocartDiv-' . $parent, 'innerHTML', $err);
			return $objResponse;
		}
		
		if (COMM_CART_MODE == 'buy_now')
		{
			$section_id = ResHelper::getArticleSection($rids[0]);
			$session->clear('my_cart' . '-' . $section_id);
			$opencart = true;
		}
		
		$msgs = array();
		foreach($rids as $key => $rid)
		{
			$section_id = ResHelper::getArticleSection($rid);
			
			if (!$section_id)
				continue;
			$errors = array();
			$msg = array();
			
			$url = 'index.php?option=com_resource&controller=article&article=' . $rid . '&category_id=' . $section_id . '&Itemid=' . JRequest::getInt('Itemid');
			
			$multivendor = COMM_MULTI_VENDOR;
			if (COMM_PAYMENT_METHOD == 'personal' && COMM_CART == 'cart')
				$multivendor = false;
			
			$price = 0;
			$tax = 0;
			$err_txt = '';
			
			$sql = "SELECT * FROM #__js_res_field_extra fex
			JOIN #__js_res_fields f ON f.id = fex.field_id WHERE fex.record_id = '$rid' AND fex.ref_id = 'download' AND f.published = '1'";
			$db->setQuery($sql);
			$allowed = 1;
			if ($ptypes = $db->loadObjectList())
			{
				$allowed = 0;
				foreach($ptypes as $ptype)
				{
					if ($ptype->field_value_id != 1)
						$allowed ++;
					else
					{
						if ($ptype->ip == '')
							$allowed ++;
					}
				}
			}
			if (!$allowed)
			{
				$err_txt = JText::_('You can not add one of the items to cart. Unique file has been already purchased.');
				$errors[] = str_replace('[NOTICE]', $err_txt, $err);
			}
			
			$cart = ($session->get('my_cart' . '-' . $section_id)) ? $session->get('my_cart' . '-' . $section_id) : array();
			$cart_set = ($session->get('my_cart' . '-' . $section_id)) ? $session->get('my_cart' . '-' . $section_id) : array();
			
			$amounts[$key] = $suite_amount * $amounts[$key];
			if ($amounts[$key] > 0)
			{
				$sql = "SELECT title, published FROM #__js_res_record WHERE id = '$rid'";
				$db->setQuery($sql);
				$art_info = $db->loadObject();
				$title = $art_info->title;
				if (!$art_info->published)
				{
					$err_txt = JText::_('You can not add unpublished product to cart');
					$errors[] = str_replace('[NOTICE]', $err_txt, $err);
					$objResponse->assign('addtocartDiv-' . $rid, 'innerHTML', $err);
					$objResponse->assign('addToCartLoading-' . $rid, 'innerHTML', '');
					return $objResponse;
				}
				
				$sql = "SELECT rv.field_value as price
				FROM #__js_res_record r
				JOIN #__js_res_fields f ON r.type_id = f.type_id
				JOIN #__js_res_record_values rv ON rv.field_id = f.id
				WHERE rv.record_id = '{$rid}' AND f.type = 'price'
				AND f.published = '1'
				group by rv.id";
				$db->setQuery($sql);
				$price = $db->loadResult();
				if ($price == '')
					$price = 0;
				if ($price)
				{
					$sql = "SELECT value FROM #__js_res_field_extra WHERE ref_id = 'price_ext' AND record_id = '{$rid}'";
					$db->setQuery($sql);
					if ($extra = $db->loadResult())
					{
						$val = unserialize($extra);
						if ($val['tax_id'])
						{
							$sql = "SELECT rate, name FROM #__jc_taxes WHERE id = '{$val['tax_id']}'";
							$db->setQuery($sql);
							$tax = $db->loadObject();
							$price += $price * $tax->rate / 100;
						}
					}
				}
				$price = round($price, 2);
				
				if (!isset($cart[$author_id]))
					$cart[$author_id] = array();
				$new_key = (isset($cart[$author_id]) && count($cart[$author_id])) ? count($cart[$author_id]) : 0;
				$amount = $amounts[$key];
				$count = 0;
				foreach($cart as $items)
				{
					$count += count($items);
					foreach($items as $item)
						$amount += $item->items_num;
				}
				$amount = ($amount == 1) ? JText::_("There is 1 item in the cart") : str_replace("[AMOUNT]", $amount, JText::_("There are [AMOUNT] items in the cart"));
				
				$author_id = $this->getSellerId($rid);
				$core = $this->getCore(COMM_CORE_CURRENCY);
				
				foreach($module as $k => $mod)
				{
					$out[$mod->id] = '';
					
					if (!$mod->params->get('define_sec', 0) && $mod->params->get('default_section') != $section_id)
						continue;
					if ($count < $mod->params->get('max_items'))
					{
						if ($mod->params->get('show_items'))
						{
							$out[$mod->id] = '<tr><td>' . ($count + 1) . '. <a href="' . $url . '">' . $title . '</a></td>';
							if ($mod->params->get('show_amount'))
								$out[$mod->id] .= '<td width="1%" align="right" nowrap>' . $amounts[$key] . ' x </td>';
							if ($mod->params->get('show_price'))
								$out[$mod->id] .= '<td align="right" nowrap>' . str_replace(array('00', 'Sign'), array(round($price, 2), $core->mark), COMM_LAYOUT_PRICE) . ' = </td>';
							if ($mod->params->get('show_sum'))
								$out[$mod->id] .= '<td align="right" nowrap>' . str_replace(array('00', 'Sign'), array(round($price * $amounts[$key], 2), $core->mark), COMM_LAYOUT_PRICE) . '</td>';
							if ($mod->params->get('show_delete'))
							{
								$return = base64_encode(JFactory::getURI()->toString());
								$remove = JRoute::_('index.php?option=com_commerce&view=cart&section_id=' . $section_id . '&return=' . $return . '&cart_item_remove=' . $author_id . '::' . $new_key, false);
								$out[$mod->id] .= '<td><a class="removeLink" href="javascript: void(0);"
					onClick=\'if(confirm("' . JText::_('Remove item?') . '")) { document.location = "' . $remove . '" } \'>
									<img src="' . JURI::root() . 'components/com_commerce/images/remove.png" alt="' . JText::_('Remove') . '" align="absmiddle">
								</a></td>';
							}
						}
					}
					$amounts_mod[$mod->id] = $amount;
					
					$total[$mod->id] = str_replace($core->mark, '', $total[$mod->id]);
					$total[$mod->id] = str_replace(array('00', 'Sign'), array(round($total[$mod->id] + $price * $amounts[$key], 2), $core->mark), COMM_LAYOUT_PRICE);
				
				}
				
				$cart[$author_id][$new_key]->items_num = $amounts[$key];
				$cart[$author_id][$new_key]->article = $rid;
				$cart[$author_id][$new_key]->link = $url;
				if ($discount)
				{
					$cart[$author_id][$new_key]->suite_discount = $discount;
				}
				
				$tangible = $this->isTangible($rid);
				$tangible = $tangible[0];
				
				// Multivendor ********
				if ($multivendor)
				{
					if (COMM_CART == 'cart')
					{
						if (count($cart) > 0)
						{
							if ($tangible)
							{
								$tang_params = new JParameter($tangible->value);
								if ($tang_params->get('weight'))
								{
									if (!$tang_params->get('storage', 0))
									{
										$err_txt = JText::_('One of the products could not be added to cart.') . '<li>' . JText::_('There are no items on storage');
										$errors[] = str_replace('[NOTICE]', $err_txt, $err);
									}
									else
									{
										$in_cart = 0;
										foreach($cart_set as $items)
										{
											foreach($items as $items)
											{
												if ($rid == $item->article)
												{
													$in_cart += $item->items_num;
												}
											}
										}
										if (!$in_cart || ($tang_params->get('storage') >= ($tang_params->get('storage') - $in_cart) && ($tang_params->get('storage') - $in_cart) > 0))
										{
											if ($amounts[$key] > ($tang_params->get('storage') - $in_cart))
											{
												$cart[$author_id][$new_key]->items_num = $tang_params->get('storage') - $in_cart;
												$msg[] = $cart[$author_id][$new_key]->items_num . ' ' . JText::_('Item(s) were added to cart only.');
											}
										}
										else
										{
											$err_txt = JText::_('One of the products could not be added to cart.') . '<li>' . JText::_('There are no items on storage more than you have added to cart');
											$errors[] = str_replace('[NOTICE]', $err_txt, $err);
										}
									}
								}
							}
							else
							{
								$ids = array();
								foreach($cart as $seller_id => $items)
								{
									foreach($items as $item)
									{
										$ids[] = $item->article;
									}
								}
								$tangibles = $this->isTangible($ids);
								if ($tangibles)
								{
									$tang = false;
									foreach($tangibles as $val)
									{
										$weights = new JParameter($val->value);
										if ($weights->get('weight'))
										{
											$tang = true;
										}
									}
									if ($tang)
									{
										if (!in_array($author_id, array_keys($cart)))
										{
											$err_txt = JText::_('You can not add this product to cart because you already have tangible product of other seller in the cart.') . '<li>' . JText::_('First delete items form the cart or finish your payment.');
											$errors[] = str_replace('[NOTICE]', $err_txt, $err);
										}
									}
								}
							}
						}
					}
					$errs[$key] = implode($errors);
					if (count($msg))
						$msgs[$key] = implode('<li>', $msg);
					if (!count($errors))
					{
						if (count($msg))
							unset($cart[$new_key]->suite_discount);
						$session->set('my_cart' . '-' . $section_id, $cart);
						
						if (count($module))
						{
							foreach($module as $mod)
							{
								if ($out[$mod->id] != '')
								{
									if (!count($cart_set))
										$objResponse->assign('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
									else
										$objResponse->append('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
								}
								if (isset($amounts[$mod->id]))
									$objResponse->assign('modCartContentAmount' . $mod->id, "innerHTML", $amounts_mod[$mod->id]);
								$objResponse->assign('modCartContentTotal-' . $mod->id, "innerHTML", '<b>' . $total[$mod->id] . '</b>');
							}
						}
						$step ++;
					}
					else
						continue;
				}
				// Multivendor ******** END
				

				// SINGLE vendor ********
				else
				{
					if ($tangible)
					{
						$tang_params = new JParameter($tangible->value);
						if ($tang_params->get('weight'))
						{
							if (!$tang_params->get('storage', 0))
							{
								$err_txt = JText::_('One of the products could not be added to cart.') . '<li>' . JText::_('There are no items on storage');
								$errors[] = str_replace('[NOTICE]', $err_txt, $err);
							}
							else
							{
								$in_cart = 0;
								foreach($cart_set as $items)
								{
									foreach($items as $item)
									{
										if ($rid == $item->article)
										{
											$in_cart += $item->items_num;
										}
									}
								}
								if (!$in_cart || ($tang_params->get('storage') >= ($tang_params->get('storage') - $in_cart) && ($tang_params->get('storage') - $in_cart) > 0))
								{
									if ($amounts[$key] > ($tang_params->get('storage') - $in_cart))
									{
										$cart[$author_id][$new_key]->items_num = $tang_params->get('storage') - $in_cart;
										$msg[] = $cart[$new_key]->items_num . ' ' . JText::_('Item(s) were added to cart only.');
									}
								}
								else
								{
									$err_txt = JText::_('One of the products could not be added to cart.') . '<li>' . JText::_('There are no items on storage more than you have added to cart.');
									$errors[] = str_replace('[NOTICE]', $err_txt, $err);
								}
							}
						}
					}
					
					if (count($cart) > 0)
					{
						if (!in_array($author_id, array_keys($cart)))
						{
							$err_txt = JText::_('Products of different sellers could not be added to cart.<li>First delete items form the cart or finish your payment.');
							$errors[] = str_replace('[NOTICE]', $err_txt, $err);
						}
						else
						{
							$errs[$key] = implode($errors);
							if (count($msg))
								$msgs[$key] = implode('<li>', $msg);
							if (!count($errors))
							{
								if (count($msg))
									unset($cart[$author_id][$new_key]->suite_discount);
								$session->set('my_cart' . '-' . $section_id, $cart);
								
								if (count($module))
								{
									foreach($module as $mod)
									{
										if (!$new_key)
											$objResponse->assign('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
										else
											$objResponse->append('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
										if (isset($amounts[$mod->id]))
											$objResponse->assign('modCartContentAmount' . $mod->id, "innerHTML", $amounts_mod[$mod->id]);
										$objResponse->assign('modCartContentTotal-' . $mod->id, "innerHTML", '<b>' . $total[$mod->id] . '</b>');
									}
								}
							}
							else
								continue;
							$step ++;
						
						}
					}
					else
					{
						$errs[$key] = implode($errors);
						$msgs[$key] = implode('<li>', $msg);
						if (!count($errors))
						{
							if (count($msg))
								unset($cart[$author_id][$new_key]->suite_discount);
							$session->set('my_cart' . '-' . $section_id, $cart);
							
							if (count($module))
							{
								foreach($module as $mod)
								{
									if (!$new_key)
										$objResponse->assign('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
									else
										$objResponse->append('modCartContent' . $mod->id, "innerHTML", $out[$mod->id]);
									if (isset($amounts[$mod->id]))
										$objResponse->assign('modCartContentAmount' . $mod->id, "innerHTML", $amounts_mod[$mod->id]);
									$objResponse->assign('modCartContentTotal-' . $mod->id, "innerHTML", '<b>' . $total[$mod->id] . '</b>');
								}
							}
							$step ++;
						
						}
					
					}
				
		// SINGLE vendor ********
				

				}
			}
			
			if (count($rids) > $step)
			{
				$err_txt = JText::_('Not all products were added to cart');
				$errs[] = str_replace('[NOTICE]', $err_txt, $err);
				$objResponse->assign('addToCartLoading-' . $parent, 'innerHTML', '');
				$objResponse->assign('addtocartDiv-' . $parent, 'innerHTML', implode($errs));
			}
			else
			{
				$err_txt = JText::_('Suite is added to cart');
				if (count($msgs))
				{
					$msg = implode('<li>', $msgs);
					if ($msg != '')
						$err_txt .= '<li>' . $msg;
				}
				$ok = str_replace('[NOTICE]', $err_txt, $ok);
				$objResponse->assign('addToCartLoading-' . $parent, 'innerHTML', '');
				$objResponse->assign('addtocartDiv-' . $parent, 'innerHTML', $ok);
			}
			if ($opencart)
			{
				$link = 'index.php?option=com_commerce&view=cart&section_id=' . $section_id . '&Itemid=' . ((COMM_CART_ITEMID != '') ? COMM_CART_ITEMID : JRequest::getInt('Itemid'));
				$link = JRoute::_($link, false);
				$objResponse->redirect($link);
			}
		}
		
		return $objResponse;
	}

}

?>